# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define oname   lucene
%define section free

Name:           lucene1
Version:        1.9.1
Release:        4%{?dist}
Epoch:          0
Summary:        High-performance, full-featured text search engine
License:        ASL 2.0
URL:            http://lucene.apache.org/
Group:          Internet/WWW/Indexing/Search
Source0:        http://www.apache.org/dist/lucene/java/lucene-1.9.1-src.tar.gz

Source1:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-parent/1.9.1/lucene-parent-1.9.1.pom
Source2:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-core/1.9.1/lucene-core-1.9.1.pom
Source3:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-demos/1.9.1/lucene-demos-1.9.1.pom
Source4:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-contrib/1.9.1/lucene-contrib-1.9.1.pom
Source5:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-analyzers/1.9.1/lucene-analyzers-1.9.1.pom
Source6:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-ant/1.9.1/lucene-ant-1.9.1.pom
Source7:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-highlighter/1.9.1/lucene-highlighter-1.9.1.pom
Source8:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-lucli/1.9.1/lucene-lucli-1.9.1.pom
Source9:        http://repo2.maven.org/maven2/org/apache/lucene/lucene-memory/1.9.1/lucene-memory-1.9.1.pom
Source10:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-misc/1.9.1/lucene-misc-1.9.1.pom
Source11:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-queries/1.9.1/lucene-queries-1.9.1.pom
Source12:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-regex/1.9.1/lucene-regex-1.9.1.pom
Source13:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-similarity/1.9.1/lucene-similarity-1.9.1.pom
Source14:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-snowball/1.9.1/lucene-snowball-1.9.1.pom
Source15:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-spellchecker/1.9.1/lucene-spellchecker-1.9.1.pom
Source16:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-surround/1.9.1/lucene-surround-1.9.1.pom
Source17:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-swing/1.9.1/lucene-swing-1.9.1.pom
Source18:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-wordnet/1.9.1/lucene-wordnet-1.9.1.pom
Source19:       http://repo2.maven.org/maven2/org/apache/lucene/lucene-xml-query-parser/1.9.1/lucene-xml-query-parser-1.9.1.pom
Patch0:		lucene-1.9-common-build_xml.patch
Patch1:		lucene-1.9-contrib-db-bdb-build_xml.patch
Patch2:		lucene-1.9-contrib-db-bdb-je-build_xml.patch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit
BuildRequires:  ant-trax
BuildRequires:  aqute-bndlib
BuildRequires:  berkeleydb
#BuildRequires:  berkeleydb-native >= 0:4.3.29
#Replaced with
BuildRequires:  db4-java

BuildRequires:  junit
BuildRequires:  javacc
BuildRequires:  java-javadoc
BuildRequires:  jline
BuildRequires:  jtidy
BuildRequires:  oro
BuildRequires:  regexp

Requires:       java >= 0:1.6.0

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Jakarta Lucene is a high-performance, full-featured text search engine
written entirely in Java. It is a technology suitable for nearly any
application that requires full-text search, especially cross-platform.

%package javadoc
Summary:        Javadoc for Lucene
Group:          Development/Documentation

%description javadoc
%{summary}.

%package demo
Summary:        Lucene demonstration library
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
%{summary}.

%package contrib
Summary:        Lucene contributed extensions
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       oro
Requires:       regexp

%description contrib
%{summary}.

%package contrib-db
Summary:        Lucene contributed bdb extensions
Group:          Internet/WWW/Indexing/Search
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       berkeleydb
#Requires:       berkeleydb-native >= 0:4.3.29
#Replaced with
Requires:       db4-java

%description contrib-db
%{summary}.


%prep
%setup -q -n %{oname}-%{version}
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build
mkdir -p docs
mkdir -p lib
export OPT_JAR_LIST="ant/ant-junit junit jaxp_transform_impl ant/ant-trax xalan-j2-serializer"
export CLASSPATH=$(build-classpath jline jtidy regexp)
pushd contrib/db/bdb/lib
#ln -sf $(build-classpath berkeleydb-native) .
#Replaced with
ln -sf $(build-classpath db) berkeleydb-native.jar
popd
pushd contrib/db/bdb-je/lib
ln -sf $(build-classpath berkeleydb) .
popd
mkdir contrib/regex/lib
pushd contrib/regex/lib
ln -sf $(build-classpath oro) jpp-oro-lib.jar
ln -sf $(build-classpath regexp) jpp-regexp-lib.jar
popd
ant -Dbuild.sysclasspath=first \
  -Djavacc.home=%{_bindir}/javacc \
  -Djavacc.jar=%{_javadir}/javacc.jar \
  -Djavacc.jar.dir=%{_javadir} \
  -Djavadoc.link=%{_javadocdir}/java \
  package 
# package test generate-test-reports


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
pushd build
echo Bundle-SymbolicName: org.apache.lucene > %{oname}-core-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-core-%{version}.osgi
java -jar $(build-classpath aqute-bndlib) wrap -properties %{oname}-core-%{version}.osgi %{oname}-core-%{version}.jar
rm %{oname}-core-%{version}.jar
mv %{oname}-core-%{version}.bar %{oname}-core-%{version}.jar
install -m 0644 %{oname}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
echo Bundle-SymbolicName: org.apache.lucene.demo > %{oname}-demos-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-demos-%{version}.osgi
java -jar $(build-classpath aqute-bndlib) wrap -properties %{oname}-demos-%{version}.osgi %{oname}-demos-%{version}.jar
rm %{oname}-demos-%{version}.jar
mv %{oname}-demos-%{version}.bar %{oname}-demos-%{version}.jar
install -m 0644 %{oname}-demos-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-demos-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

pushd contrib
echo Bundle-SymbolicName: org.apache.lucene.analysis > %{oname}-analyzers-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-analyzers-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.ant > %{oname}-ant-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-ant-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.search.highlight > %{oname}-highlighter-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-highlighter-%{version}.osgi
echo Bundle-SymbolicName: lucli > %{oname}-lucli-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-lucli-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.index.memory > %{oname}-memory-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-memory-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.misc > %{oname}-misc-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-misc-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.search.queries > %{oname}-queries-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-queries-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.search.regex > %{oname}-regex-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-regex-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.search.similar > %{oname}-similarity-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-similarity-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.analysis.snowball > %{oname}-snowball-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-snowball-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.search.spell > %{oname}-spellchecker-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-spellchecker-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.queryParser.surround > %{oname}-surround-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-surround-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.swing > %{oname}-swing-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-swing-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.wordnet > %{oname}-wordnet-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-wordnet-%{version}.osgi
echo Bundle-SymbolicName: org.apache.lucene.xmlparser > %{oname}-xml-query-parser-%{version}.osgi
echo Bundle-Version: %{version} >> %{oname}-xml-query-parser-%{version}.osgi
# contrib jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib
for c in analyzers ant highlighter lucli memory misc queries regex similarity snowball spellchecker surround swing wordnet xml-query-parser; do
    pushd ${c}
    java -jar $(build-classpath aqute-bndlib) wrap -properties ../%{oname}-${c}-%{version}.osgi %{oname}-${c}-%{version}.jar
    install -m 0644 ../%{oname}-${c}-%{version}.bar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib/%{oname}-${c}-%{version}.jar
    popd
done
popd
popd
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# bdb contrib jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db
install -m 0644 build/contrib/db/bdb/%{oname}-bdb-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db
install -m 0644 build/contrib/db/bdb-je/%{oname}-bdb-je-%{version}.jar \
		$RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-contrib-db && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.apache.lucene lucene-parent %{version} JPP %{name}-parent
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.apache.lucene lucene-core %{version} JPP %{name}
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-demos.pom
%add_to_maven_depmap org.apache.lucene lucene-demos %{version} JPP %{name}-demos
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-contrib.pom
%add_to_maven_depmap org.apache.lucene lucene-contrib %{version} JPP %{name}-contrib
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-analyzers.pom
%add_to_maven_depmap org.apache.lucene lucene-analyzers %{version} JPP/%{name}-contrib %{oname}-analyzers
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-ant.pom
%add_to_maven_depmap org.apache.lucene lucene-ant %{version} JPP/%{name}-contrib %{oname}-ant
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-highlighter.pom
%add_to_maven_depmap org.apache.lucene lucene-highlighter %{version} JPP/%{name}-contrib %{oname}-highlighter
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-lucli.pom
%add_to_maven_depmap org.apache.lucene lucene-lucli %{version} JPP/%{name}-contrib %{oname}-lucli
install -m 644 %{SOURCE9} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-memory.pom
%add_to_maven_depmap org.apache.lucene lucene-memory %{version} JPP/%{name}-contrib %{oname}-memory
install -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-misc.pom
%add_to_maven_depmap org.apache.lucene lucene-misc %{version} JPP/%{name}-contrib %{oname}-misc
install -m 644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-queries.pom
%add_to_maven_depmap org.apache.lucene lucene-queries %{version} JPP/%{name}-contrib %{oname}-queries
install -m 644 %{SOURCE12} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-regex.pom
%add_to_maven_depmap org.apache.lucene lucene-regex %{version} JPP/%{name}-contrib %{oname}-regex
install -m 644 %{SOURCE13} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-similarity.pom
%add_to_maven_depmap org.apache.lucene lucene-similarity %{version} JPP/%{name}-contrib %{oname}-similarity
install -m 644 %{SOURCE14} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-snowball.pom
%add_to_maven_depmap org.apache.lucene lucene-snowball %{version} JPP/%{name}-contrib %{oname}-snowball
install -m 644 %{SOURCE15} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-spellchecker.pom
%add_to_maven_depmap org.apache.lucene lucene-spellchecker %{version} JPP/%{name}-contrib %{oname}-spellchecker
install -m 644 %{SOURCE16} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-surround.pom
%add_to_maven_depmap org.apache.lucene lucene-surround %{version} JPP/%{name}-contrib %{oname}-surround
install -m 644 %{SOURCE17} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-swing.pom
%add_to_maven_depmap org.apache.lucene lucene-swing %{version} JPP/%{name}-contrib %{oname}-swing
install -m 644 %{SOURCE18} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-wordnet.pom
%add_to_maven_depmap org.apache.lucene lucene-wordnet %{version} JPP/%{name}-contrib %{oname}-wordnet
install -m 644 %{SOURCE19} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-contrib-%{oname}-xml-query-parser.pom
%add_to_maven_depmap org.apache.lucene lucene-xml-query-parser %{version} JPP/%{name}-contrib %{oname}-xml-query-parser

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/api/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# webapp
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 0644 build/%{oname}web.war \
  $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/%{oname}web.war

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CHANGES.txt LICENSE.txt README.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/%{name}-%{version}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files contrib
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-contrib

%files contrib-db
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-contrib-db

%files demo
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-demos-%{version}.jar
%{_javadir}/%{name}-demos.jar

%changelog
* Wed Oct 13 2010 Ralph Apel <r.apel@r-apel.de> 0:1.9.1-4
- Still required in JPP6 ( e.g. for eclipse stuff)
- Add poms, depmap frags, osgi metadata
- Add -regex contrib jar

* Fri Nov 14 2008 David Walluck <dwalluck@redhat.com> 0:1.9.1-3
- rename to lucene1

* Fri Jun 28 2008 David Walluck <dwalluck@redhat.com> 0:1.9.1-2
- fix build (missing ant-trax)
- fix License
- remove javadoc scriptlets

* Wed Mar 29 2006 Ralph Apel <r.apel@r-apel.de> 0:1.9.1-1jpp
- Upgrade to 1.9.1

* Tue Apr 26 2005 Ville Skyttä <scop at jpackage.org> - 0:1.4.3-2jpp
- Add unversioned javadoc dir symlink.
- Crosslink with local JDK javadocs.
- Convert specfile to UTF-8.
- Fix URLs.

* Mon Jan 10 2005 Kaj J. Niemi <kajtzu@fi.basen.net> 0:1.4.3
- 1.4.3

* Mon Aug 23 2004 Fernando Nasser <fnasser at redhat.com> - 0:1.3-3jpp
- Rebuild with Ant 1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.3-2jpp
- Upgrade to Ant 1.6.X

* Wed Jan 21 2004 David Walluck <david@anti-microsoft.org> 0:1.3-1jpp
- 1.3

* Wed Mar 26 2003 Ville Skyttä <scop at jpackage.org> - 0:1.2-2jpp
- Rebuilt for JPackage 1.5.

* Thu Mar  6 2003 Ville Skyttä <scop at jpackage.org> - 1.2-1jpp
- First JPackage release.
